#lang racket/base
(require racket/string)

(define (make-x n [indent 0])
  (let ([indentation (make-string indent #\space)])
    (if (zero? n)
        (string-append indentation "x")
        (let* ([spacing (make-string (sub1 (* 2 n)) #\space)]
               [line (string-append indentation "x" spacing "x")])
          (string-join (list line (make-x (sub1 n) (add1 indent)) line) "\n")))))

(for ([i (in-range 5)])
  (displayln (make-x i))
  (newline))
