#lang racket/base
;; Implements a division algorithm explained in
;; http://www.youtube.com/user/glad2teach#p/u/1/IIwlBjNLpjI
(require tests/eli-tester)

(define (discard-last-digit n)
  (let ([n/str (number->string n)])
    (values
     (string->number (substring n/str 0 (sub1 (string-length n/str))))
     )))

(define (/9 n [previous-digit #f])
  (cond
    [(= n 9) 1]
    [(< n 9) 0]
    [else (let ([n/str (number->string n)])
            (discard-last-digit
             (+ n
                (discard-last-digit n))))]))

(test
 ; Less or equal than 9
 (/9 1) => 0
 (/9 9) => 1
 
 ; Can answer by taking the first digit
 (/9 10) => 1
 (/9 23) => 2
 
 ; Can ignore rest of division, 100 + 10{0} = 110 => 11{0} => 11
 (/9 100) => 11
 (/9 123) => 13
 
 ; Can NOT ignore the rest (has carry one)
 (/9 18) => 2
 ;(/9 54) => 6
 ;(/9 72) => 8 ; 8 = 7 + 1
 ;(/9 221013) => 24557
 )