#lang racket/base
(require rackunit rackunit/gui)

(define (divisible? m n)
  (if (zero? n)
      #f
      (zero? (remainder m n))))

(define (fizzbuzz n)
  (cond
    [(divisible? n 15) "fizzbuzz"]
    [(divisible? n 3) "fizz"]
    [(divisible? n 5) "buzz"]
    [else n]))

(define-test-suite
  FizzBuzz
  (test-equal?
   "Regular numbers are not affected"
   (fizzbuzz 4) 4)
  
  (test-case
   "3 is fizz"
   (check-equal? (fizzbuzz 3) "fizz"))
  
  (test-case
   "5 is buzz"
   (check-equal? (fizzbuzz 5) "buzz"))
  
  (test-equal?
   "15 is fizzbuzz"
   (fizzbuzz 15) "fizzbuzz")
  
  (test-case
   "Multiples of 3 are fizz"
   (check-equal? (fizzbuzz 81) "fizz"))
  
  (test-case
   "Multiples of 5 are buzz"
   (check-equal? (fizzbuzz 25) "buzz"))
  
  (test-equal?
   "Multiples of 3 and 5 are fizzbuzz"
   (fizzbuzz 45) "fizzbuzz"))

(test/gui FizzBuzz)