#lang racket
; The objective here is to show how to use images and picts
; Inspiration: racket mailing list
; http://lists.racket-lang.org/users/archive/2011-August/047089.html

(require (prefix-in pp: picturing-programs)
         (prefix-in ss: slideshow/pict)
         racket/class)

(define composed-image
  (pp:underlay
   (pp:rectangle 390 250 "solid" "darkgreen")
   (pp:rhombus 200 120 "solid" "yellow")
   (pp:circle 60 "solid" "darkblue")))

(define primitive-image
  (pp:circle 60 "solid" "orange"))

(define built-image
  (pp:build3-image
   10 10
   (λ (x y) 56)
   (λ (x y) 235)
   (λ (x y) 30)))

; original images
composed-image
primitive-image
built-image


; converted to pict
; error (ss:bitmap (send composed-image get-bitmap))
; error (ss:bitmap (send primitive-image get-bitmap))
(ss:bitmap (send built-image get-bitmap))


#| 

Why the heck build3-image returns an image-snip% while underlay and
primitives return an image% (mrlib/image-core), incompatible with
the documented image% (wxme/image)???

|#