#lang racket/base
(require racket/list
         rackunit
         "list-merge.rkt")

;; list? -> list?
(define (merge-sort lst)
  (cond [(<= (length lst) 1) lst]
        [else (let-values ([(l r) (split-in-half lst)])
                (list-merge (merge-sort l)
                            (merge-sort r)))]))

;; list? -> list? list?
(define (split-in-half lst)
  (split-at lst (quotient (length lst) 2)))

(check-equal? (merge-sort '(1 2 3)) '(1 2 3))
(check-equal? (merge-sort '(1 3 2)) '(1 2 3))
(check-equal? (merge-sort '(3 2 1)) '(1 2 3))
(define L (shuffle (build-list 1000 values)))
(check-equal? (merge-sort L) (sort L <))