#lang racket/base
(require rackunit)
(require racket/list)

; Valor das notas em ordem decrescente
(define possíveis-notas '(100 50 10 5 2 1))


(define (max< notas x)
  (when (not (empty? notas))
    (if (<= (car notas) x)
        (car notas)
        (max< (cdr notas) x))))


(define (notas x)
  (let ([nota (max< possíveis-notas x)])
    (if (zero? x)
        null
        (cons nota (notas (- x nota))))))

(check-equal? (notas 36) '(10 10 10 5 1))
(check-equal? (notas 70) '(50 10 10))
