#lang racket
(require db)

(define conn (sqlite3-connect #:database 'memory))
(query-exec conn
            "create table movies (name TEXT, date INTEGER)")

(define movies '(("Tropa de Elite 2" . 2010)
                 ("Some name" . 1999)
                 ("Yet Another Film" . 1999)
                 ("The Butterfly Effect" . 2003)))

(for ([m (in-list movies)])
  (query-exec conn
              "insert into movies values (?, ?)" (car m) (cdr m)))

(define q (prepare conn "select * from movies"))

;(query conn q)
(query-rows conn q #:group #("date"))

(query-list conn "select distinct date from movies order by date asc")