#! /usr/bin/env python
# -*- coding: utf8 -*-

from codecs import open
import sys

def translate(src, dst):
    doc = open(src, encoding='utf8').read()
    dst_file = open(dst, 'w', encoding='utf8')
    
    for x, y in translate_strings:
        if x[0] != '(':
            doc = doc.replace('"%s"' % x, '"%s"' % y)
        else:
            doc = doc.replace(x, y)
        
    dst_file.write(doc)
    dst_file.close()


translate_strings = [
  [
    u"Introduction to Racket", 
    u"Introdução ao Racket"
  ], 
  [
    u"""(vc-append 0
            (t "Matthew Might")
            (colorize (bt "University of Utah") "red")
            (colorize (t "matt.might.net") "blue"))""",
    u"""(vc-append 0
            (t "Rodolfo Carvalho")
            (it "baseado nos slides de Matthew Might")
            (blank 50)
            (colorize (bt "Dojo Rio") "red")
            (colorize (t "rodolfocarvalho.net") "blue"))"""
  ], 
  [
    u"Why learn Racket (or Lisp)?", 
    u"Por que aprender Racket (ou Lisp)?"
  ], 
  [
    u"A good FORTRAN programmer can write FORTRAN in any language.", 
    u"Um bom programador FORTRAN pode escrever FORTRAN em qualquer linguagem."
  ], 
  [
    u"A good Lisp programmer can write any language in Lisp.", 
    u"Um bom programador Lisp pode escrever qualquer linguagem em Lisp."
  ], 
  [
    u"A good C programmer can write C in any language.", 
    u"Um bom programador C pode escrever C em qualquer linguagem."
  ], 
  [
    u"A good Racket programmer can write any language in Racket.", 
    u"Um bom programador Racket pode escrever qualquer linguagem em Racket."
  ], 
  [
    u"What is Racket?", 
    u"O que é Racket?"
  ], 
  [
    u"Lisp is λ-calculus done right.", 
    u"Lisp é λ-calculus bem feito."
  ], 
  [
    u"Scheme is Lisp done right.", 
    u"Scheme é Lisp bem feito."
  ], 
  [
    u"Racket is Scheme done right.", 
    u"Racket é Scheme bem feito."
  ], 
  [
    u"Origins of Scheme: Lisp", 
    u"Origens do Scheme: Lisp"
  ], 
  [
    u"Lisp created in 1958", 
    u"Lisp criado em 1958"
  ], 
  [
    u"Based on λ-calculus", 
    u"Baseado em λ-calculus"
  ], 
  [
    u"Based on list-processing", 
    u"Baseado em processamento de lista"
  ], 
  [
    u"S-Expression syntax", 
    u"Sintaxe S-Expression"
  ], 
  [
    u"Code acts as data", 
    u"Código funciona como dado"
  ], 
  [
    u"Data acts as code", 
    u"Dado funciona como código"
  ], 
  [
    u"Core S-Expression syntax", 
    u"Sintaxe básica de uma S-Expression"
  ], 
  [
    u"S-Expressions: Benefits", 
    u"S-Expressions: Benefícios"
  ], 
  [
    u"Human-readable", 
    u"Legível"
  ], 
  [
    u"Human-writable", 
    u"Escrevível"
  ], 
  [
    u"Easy to parse", 
    u"Fácil de fazer parsing"
  ], 
  [
    u"S-Expression example", 
    u"Exemplo de S-Expression"
  ], 
  [
    u"(ships                  ", 
    u"(navios                  "
  ], 
  [
    u" (ship (name Enterprise)", 
    u" (navio (name Enterprise)"
  ], 
  [
    u"       (x    120)       ", 
    u"       (x    120)        "
  ], 
  [
    u"       (y    150))      ", 
    u"       (y    150))       "
  ], 
  [
    u" (ship (name Galactica)   ", 
    u" (navio (name Galactica) "
  ], 
  [
    u"       (x    130)       ", 
    u"       (x    130)        "
  ], 
  [
    u"       (y    42)))      ", 
    u"       (y    42)))       "
  ], 
  [
    u"XML: High-calorie S-Expressions", 
    u"XML: S-Expressions de alto teor calórico"
  ], 
  [
    u"<ships>", 
    u"<navios>"
  ], 
  [
    u" <ship>", 
    u" <navio>"
  ], 
  [
    u"  <name>Enterprise</name>", 
    u"  <name>Enterprise</name>"
  ], 
  [
    u"  <x>120</x>", 
    u"  <x>120</x>"
  ], 
  [
    u"  <y>150</y>", 
    u"  <y>150</y>"
  ], 
  [
    u" </ship>", 
    u" </navio>"
  ], 
  [
    u"  <name>Galactica</name>", 
    u"  <name>Galactica</name>"
  ], 
  [
    u"  <x>130</x>", 
    u"  <x>130</x>"
  ], 
  [
    u"  <y>42</y>", 
    u"  <y>42</y>"
  ], 
  [
    u"</ships>", 
    u"</navios>"
  ], 
  [
    u"S-Expressions: Universal syntax", 
    u"S-Expressions: Sintaxe universal"
  ], 
  [
    u"class Dog extends Pet {", 
    u"class Cachorro extends Animal {"
  ], 
  [
    u" void bark() { ", 
    u" void latir() {"
  ], 
  [
    u"  print(\\\"woof\\\") ; ", 
    u"  print(\\\"au-au\\\") ; "
  ], 
  [
    u"}}", 
    u"}}"
  ], 
  [
    u"(class Dog extends Pet", 
    u"(class Cachorro extends Animal"
  ], 
  [
    u" (void (bark) ", 
    u" (void (latir) "
  ], 
  [
    u"  (print \\\"woof\\\")))", 
    u"  (print \\\"au-au\\\")))"
  ], 
  [
    u"(class", 
    u"(class"
  ], 
  [
    u" (name    Dog)", 
    u" (name    Cachorro)"
  ], 
  [
    u" (extends Pet)", 
    u" (extends Animal)"
  ], 
  [
    u" (methods ", 
    u" (methods "
  ], 
  [
    u"  (method ", 
    u"  (method "
  ], 
  [
    u"   (name bark)", 
    u"   (name latir)"
  ], 
  [
    u"   (args ())", 
    u"   (args ())"
  ], 
  [
    u"   (type (-> () void)) ", 
    u"   (type (-> () void)) "
  ], 
  [
    u"   (body (print \\\"woof\\\"))))))", 
    u"   (body (print \\\"au-au\\\"))))))"
  ], 
  [
    u"Lisp done right, 1978", 
    u"Lisp bem feito, 1978"
  ], 
  [
    u"Fixed scoping oversight", 
    u"Corrigiu problemas com escopo"
  ], 
  [
    u"Purified formal semantics", 
    u"Purificou a semântica formal"
  ], 
  [
    u"Hygienic macro system", 
    u"Sistema de macros higiênico"
  ], 
  [
    u"Scheme done right, 2010", 
    u"Scheme bem feito, 2010"
  ], 
  [
    u"Added huge library system", 
    u"Muitas bibliotecas"
  ], 
  [
    u"Adds modules, structs, etc.", 
    u"Módulos, structs, etc."
  ], 
  [
    u"Batteries included", 
    u"Baterias incluídas"
  ], 
  [
    u"Racket example: Factorial", 
    u"Exemplo em Racket: Fatorial"
  ], 
  [
    u"Racket programs", 
    u"Programas em Racket"
  ], 
  [
    u"Definitions", 
    u"Definições"
  ], 
  [
    u"A subset of Scheme expressions", 
    u"Um subconjunto das expressões de Scheme"
  ], 
  [
    u"A tour of Racket", 
    u"Um passeio pelo Racket"
  ], 
  [
    u"Numbers", 
    u"Números"
  ], 
  [
    u"Integers: ", 
    u"Inteiros: "
  ], 
  [
    u"Rationals: ", 
    u"Racionais: "
  ], 
  [
    u"\\\"Reals\\\": ", 
    u"\\\"Reais\\\": "
  ], 
  [
    u"Imaginary: ", 
    u"Imaginários: "
  ], 
  [
    u"Complex: ", 
    u"Complexos: "
  ], 
  [
    u"Precise: ", 
    u"Precisos: "
  ], 
  [
    u"Booleans", 
    u"Booleanos"
  ], 
  [
    u"Boolean literals ", 
    u"Literais booleanos "
  ], 
  [
    u"Only ", 
    u"Só "
  ], 
  [
    u" is false", 
    u" é falso"
  ], 
  [
    u"Anything else is true", 
    u"Qualquer outra coisa é verdadeira"
  ], 
  [
    u"Lists", 
    u"Listas"
  ], 
  [
    u"Quoted S-Expressions", 
    u"Quoted S-Expressions"
  ], 
  [
    u"Primitives", 
    u"Primitivas"
  ], 
  [
    u"Arithmetic: ", 
    u"Aritméticas: "
  ], 
  [
    u"Types: ", 
    u"Tipos: "
  ], 
  [
    u"Lists: ", 
    u"Listas: "
  ], 
  [
    u"Equality: ", 
    u"Igualdade: "
  ], 
  [
    u"Ex:", 
    u"Ex:"
  ], 
  [
    u" binds values to variable names", 
    u" atribui valores a nomes de variáveis"
  ], 
  [
    u" binds values to variable names sequentially", 
    u" atribui valores a nomes de variáveis em sequência"
  ], 
  [
    u"Variables", 
    u"Variáveis"
  ], 
  [
    u"Any symbol allowed", 
    u"Qualquer símbolo é permitido"
  ], 
  [
    u"Roughly: ", 
    u"Grosseiramente: "
  ], 
  [
    u"λ produces anonymous functions", 
    u"λ produz funções anônimas"
  ], 
  [
    u"Lexical scope", 
    u"Escopo léxico"
  ], 
  [
    u"To what does the following evaluate?", 
    u"O que faz o código abaixo?"
  ], 
  [
    u"λ-terms capture bindings in scope", 
    u"λ-terms capturam vínculos no escopo"
  ], 
  [
    u"WYSIWYG for anonymous functions", 
    u"WYSIWYG para funções anônimas"
  ], 
  [
    u"Obligatory derivative example", 
    u"Exemplo obrigatório com derivadas"
  ], 
  [
    u"Conditionals", 
    u"Condicionais"
  ], 
  [
    u"""(cond
                      ((< 3 0) 'negative)
                      ((= 3 0) 'zero)
                      ((> 3 0) 'positive))""",
    u"""(cond
                      ((< 3 0) 'negativo)
                      ((= 3 0) 'zero)
                      ((> 3 0) 'positivo))"""
  ], 
  [
    u"Quasiquotes", 
    u"Quasiquotes"
  ], 
  [
    u"Special syntax for constructing literals", 
    u"Sintaxe especial para a construção de literais"
  ], 
  [
    u"Mutating variables", 
    u"Variáveis mutáveis"
  ], 
  [
    u" sequences expressions, like ", 
    u" sequencia expressões, como "
  ], 
  [
    u" in C", 
    u" em C"
  ], 
  [
    u" assigns to a variable, like ", 
    u" atribui a uma variável, como "
  ], 
  [
    u"Pattern-matching", 
    u"Casamento de padrões"
  ], 
  [
    u"Powerful tool for dissecting data like trees", 
    u"Ferramenta poderosa para trabalhar com dados, incluindo estruturas complexas como árvores, URLs, ..."
  ]
]


if __name__ == '__main__':
    assert len(sys.argv) == 3, "USAGE: %s SRC DEST" % (sys.argv[0],)
    src, dst = sys.argv[1:3]
    translate(src, dst)
